m4_divert(-1)
m4_changequote([,])
m4_define([d][nl],[m4_d][nl])
m4_changecom([.\"])

dnl *** basic macros ***

dnl M_EXPAND(EXPR)
dnl M_THROUGH(UNQUOTED_LIST)
dnl M_QUOTE(UNQUOTED_LIST)
dnl M_RAWQUOTE(UNQUOTED_LIST)
dnl M_CAR(UNQUOTED_LIST)
dnl M_QCAR(UNQUOTED_LIST)
dnl M_QQCAR(UNQUOTED_LIST)
dnl M_CDR(NON_EMPTY_UNQUOTED_LIST)
dnl M_CDRM(NON_SINGULAR_UNQUOTED_LIST)
dnl Note: M_QCAR is not equivalent to M_QUOTE(M_CAR(x))
m4_define([M_EXPAND],[$*])
m4_define([M_THROUGH],[$@])
m4_define([M_QUOTE],[[$@]])
m4_define([M_RAWQUOTE],[[[$*]]])
m4_define([M_CAR],[$1])
m4_define([M_QCAR],[[$1]])
m4_define([M_QQCAR],[[[$1]]])
m4_define([M_CDR],[m4_ifelse($#,1,,[M_QUOTE(m4_shift($@))])])
m4_define([M_CDRM],[M_QUOTE(m4_shift($@))])

dnl M_CANON(QUOTED_LIST)
dnl M_QCANON(QUOTED_LIST)
m4_define([M_CANON],[M_EXPAND(M_QCANON([$1]))])
m4_define([M_QCANON],[m4_ifelse([$1],,,[M_QUOTE($1)])])

dnl M_COUNT(QUOTED_LIST)
dnl M_COUNT_NZ(NON_EMPTY_UNQUOTED_LIST)
m4_define([M_COUNT],[m4_ifelse([$1],,0,[M_COUNT_NZ($1)])])
m4_define([M_COUNT_NZ],[$#])

dnl M_PROGN(EXPR...)
m4_define([M_PROGN],[$1[]m4_ifelse([$*],,,[M_PROGN(m4_shift($@))])])
dnl M_SPC
dnl M_TAB
dnl M_NL
m4_define([M_SPC],[ ])
m4_define([M_TAB],[	])
m4_define([M_NL],[
])

dnl M_FOREACH(VAR, LIST, EXPR, [EXTRA])
dnl Take notice of difference from m4sugar's m4_foreach.
dnl Example:
dnl m4_define(active, [ACT, IVE])
dnl M_FOREACH(Var, [active, active], [-Var-])
dnl => -ACT--IVE--ACT--IVE-
dnl M_FOREACH(Var, [[active], [active]], [-M_EXPAND(Var)-])
dnl => -ACT, IVE--ACT, IVE-
dnl M_FOREACH(Var, [[active], [active]], [-Var-])
dnl => -active--active-
m4_define([M_FOREACH],[M__FOREACH_IMPL([$1],M_QCANON([$2]),[$3],[$4])])
m4_define([M__FOREACH_IMPL],
[m4_ifelse([$2],,,
    [M_PROGN([m4_pushdef([$1])],
	[M__FOREACH_LOOP([$1],[$3],[$4],M_COUNT_NZ($2),
	    M__FOREACH_SPLIT($2))],
	[m4_popdef([$1])],
    )])dnl
])
m4_define([M__FOREACH_SPLIT],[[$1],M_QUOTE(m4_shift($@))])
dnl M__FOREACH_LOOP(VAR, EXPR, EXTRA, COUNT, CAR, CDR)
m4_define([M__FOREACH_LOOP],
[m4_define([$1],[[$5]])m4_ifelse($4,1,[$2[]],
    [$2[$3]M__FOREACH_LOOP([$1],[$2],[$3],m4_decr($4),M__FOREACH_SPLIT($6))dnl
])])
dnl M_TRANSFORM(VAR, LIST, EXPR, [EXTRA])
dnl Example:
dnl m4_define(active, [ACT, IVE])
dnl M_TRANSFORM(Var, [active, active], [-Var-])
dnl => [-ACT-],[-IVE-],[-ACT-],[-IVE-]
dnl M_TRANSFORM(Var, [[active], [active]], [-M_EXPAND(Var)-])
dnl => [-ACT],[IVE-],[-ACT],[IVE-]
dnl M_TRANSFORM(Var, [[active], [active]], [-M_QUOTE(M_EXPAND(Var))-])
dnl => [-[ACT],[IVE]-],[-[ACT],[IVE]-]
dnl M_TRANSFORM(Var, [[active], [active]], [-Var-])
dnl => [-active-],[-active-]
m4_define([M_TRANSFORM],[M_FOREACH([$1],[$2],[M_QUOTE($3)],[,$4])])

dnl *** references ***

m4_define([VAR],[[\fI]$1[\fP]])
m4_define([TYPE],[[\fI]$1[\fP]])
m4_define([FUNC],[[\fI]$1[\fP]])
m4_define([ERR],[[\fI]$1[\fP]])

dnl *** definitions/declarations ***

dnl ARGDEF(TYPE, STARS, ARGNAME)
m4_define([ARGDEF],[$1 $2[\fI]$3[\fP]])
dnl FUNCDEF(TYPE, STARS, FUNCNAME,[ARGLIST])
dnl ARGLIST: [[ARG1], [ARG2], ...]
dnl ARGn: TYPE, STARS, ARGNAME
m4_define([FUNCDEF],[dnl
.LP
$1
.br
$2[\fB]$3[\fP(]m4_ifelse([$4],,[void],
    [M_FOREACH([M__ARG],[$4],
	[ARGDEF(M_EXPAND(M__ARG))],[, ])])[]dnl
[)];dnl
])

m4_define([ERRDEF],[.IP "RETURN VALUE"])

m4_divert(0)m4_dnl
